//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//
// copyright            : (C) 2013 by Eran Ifrah
// file name            : compilerfiletypespage.h
//
// -------------------------------------------------------------------------
// A
//              _____           _      _     _ _
//             /  __ \         | |    | |   (_) |
//             | /  \/ ___   __| | ___| |    _| |_ ___
//             | |    / _ \ / _  |/ _ \ |   | | __/ _ )
//             | \__/\ (_) | (_| |  __/ |___| | ||  __/
//              \____/\___/ \__,_|\___\_____/_|\__\___|
//
//                                                  F i l e
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#ifndef __compilerfiletypespage__
#define __compilerfiletypespage__

/**
@file
Subclass of CompilerFileTypesBase, which is generated by wxFormBuilder.
*/

#include "compiler_pages.h"
#include "advanced_settings.h"
#include "compiler.h"

/** Implementing CompilerFileTypesBase */
class CompilerFileTypePage : public CompilerFileTypesBase, public ICompilerSubPage
{
	wxString m_cmpname;
	long m_selectedFileType;
protected:
	// Handlers for CompilerFileTypesBase events.
	void OnFileTypeActivated( wxListEvent& event );
	void OnFileTypeDeSelected( wxListEvent& event );
	void OnFileTypeSelected( wxListEvent& event );
	void OnNewFileType( wxCommandEvent& event );
	void OnDeleteFileType( wxCommandEvent& event );

	void InitFileTypes();
public:
	/** Constructor */
	CompilerFileTypePage( wxWindow* parent, const wxString &cmpname );
	virtual void Save(CompilerPtr cmp);
};

#endif // __compilerfiletypespage__
