//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//
// copyright            : (C) 2013 by Eran Ifrah
// file name            : compilerswitchespage.h
//
// -------------------------------------------------------------------------
// A
//              _____           _      _     _ _
//             /  __ \         | |    | |   (_) |
//             | /  \/ ___   __| | ___| |    _| |_ ___
//             | |    / _ \ / _  |/ _ \ |   | | __/ _ )
//             | \__/\ (_) | (_| |  __/ |___| | ||  __/
//              \____/\___/ \__,_|\___\_____/_|\__\___|
//
//                                                  F i l e
//
//    This program is free software; you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation; either version 2 of the License, or
//    (at your option) any later version.
//
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

#ifndef __compilerswitchespage__
#define __compilerswitchespage__

/**
@file
Subclass of CompilerSwitchesBase, which is generated by wxFormBuilder.
*/

#include "compiler_pages.h"
#include "advanced_settings.h"
#include "compiler.h"

/** Implementing CompilerSwitchesBase */
class CompilerSwitchesPage : public CompilerSwitchesBase, public ICompilerSubPage
{
	wxString m_cmpname;
	wxString m_selSwitchName ;
	wxString m_selSwitchValue;
protected:
	// Handlers for CompilerSwitchesBase events.
	void OnItemActivated( wxListEvent& event );
	void OnItemSelected( wxListEvent& event );

	void EditSwitch();
	void InitSwitches();
	void AddSwitch(const wxString &name, const wxString &value, bool choose);
public:
	/** Constructor */
	CompilerSwitchesPage( wxWindow* parent, const wxString &cmpname );
	virtual void Save(CompilerPtr cmp);
};

#endif // __compilerswitchespage__
